#include <cstdlib>
#include <cstdio>
#include <ORBitservices/CosNaming.hh>
#include "account-cpp-stubs.hh"

int
main (int argc, char *argv[])
{
  CORBA::ORB_var orb = CORBA::ORB_init (argc, argv, "orbit-local-orb");

  /*
   * Connect to the Bank
   */
  CORBA::Object_var nameobj = orb->resolve_initial_references("NameService");
  CosNaming::NamingContext_var inc = CosNaming::NamingContext::_narrow(nameobj);

  // create a name
  CosNaming::Name name;
  name.length(1);
  name[0].id = CORBA::string_dup("bank");
  CORBA::Object_var obj = inc->resolve (name);

  if (CORBA::is_nil (obj)) {
    printf ("oops: bind to Bank failed\n");
    exit (1);
  }

  Bank_var bank = Bank::_narrow (obj);
  assert (!CORBA::is_nil (bank));

  /*
   * Open an account
   */

  Account_var account = bank->create ();

  if (CORBA::is_nil (account)) {
    printf ("oops: account is nil\n");
    exit (1);
  }

  /*
   * Deposit and withdraw some money
   */

  account->deposit (700);
  account->withdraw (450);

  printf ("Balance is %ld.\n", account->balance ());

  return 0;
}
