/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*- */
#include <iostream>
#include <glib.h>
#include <ORBitservices/CosNaming.hh>
#include "helloworld-cpp-stubs.hh"

using namespace std;
	
int
main(int argc, char *argv[])
{
	// initialise the orb
	CORBA::ORB_var orb = CORBA::ORB_init(argc, argv, "orbit-local-orb");

	// get the name server initial context
	CORBA::Object_var nameobj = orb->resolve_initial_references("NameService");
	CosNaming::NamingContext_var inc; // initial naming context
	inc = CosNaming::NamingContext::_narrow(nameobj);
	g_assert(!CORBA::is_nil(inc));

	// create a name
	CosNaming::Name name;
	name.length(1);
	name[0].id = CORBA::string_dup("helloworld_server");

	// and look up the object in the name service
	CORBA::Object_var obj = inc->resolve(name);
	hellomodule::Hello_var ptr = hellomodule::Hello::_narrow(obj);

	// now execute a call to the server
	const char* message = "Hello server, from client!";
	const char* reply = ptr->helloWorld(message);

	cout << "Client: Reply was \"" << reply << "\"" << endl;
	
	return 0;  // pass
}
