/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*- */
#include <fstream>
#include <glib.h>
#include <ORBitservices/CosNaming.hh>
#include "helloworld-impl.hh"

int main (int argc, char* argv[])
{
	// Initialize the CORBA orb
	CORBA::ORB_var orb = CORBA::ORB_init (argc, argv);

	
	// Get the root POA
	CORBA::Object_var pfobj = orb->resolve_initial_references("RootPOA");
	PortableServer::POA_var rootPOA =
        PortableServer::POA::_narrow(pfobj);

	// Activate the root POA's manager
	PortableServer::POAManager_var mgr = rootPOA->the_POAManager();
	mgr->activate();

	// Create a Servant and explicitly create a CORBA object
	hellomodule::Hello_impl servant;
	CORBA::Object_var object = servant._this();

	// get a ref to the nameservice initial context
	CORBA::Object_var nameobj = orb->resolve_initial_references("NameService");
	CosNaming::NamingContext_var inc; // initial naming context
	inc = CosNaming::NamingContext::_narrow(nameobj);
	g_assert(!CORBA::is_nil(inc));

	// bind the object to the name in the nameserver
	CosNaming::Name name;
	name.length(1);
	name[0].id = CORBA::string_dup("helloworld_server");
	inc->bind(name,object);

	// run the server event loop
	orb->run();
}
